package com.sun.jmx.snmp.internal;

import com.sun.jmx.snmp.mpm.SnmpMsgTranslator;
import com.sun.jmx.snmp.SnmpTooBigException;
import com.sun.jmx.snmp.SnmpSecurityParameters;
import com.sun.jmx.snmp.SnmpStatusException;
import com.sun.jmx.snmp.SnmpPdu;
import com.sun.jmx.snmp.SnmpParams;
import com.sun.jmx.snmp.SnmpPduFactory;

public interface SnmpMsgProcessingModel extends SnmpModel
{
    public abstract SnmpOutgoingRequest getOutgoingRequest(SnmpPduFactory p0);
    
    public abstract SnmpIncomingRequest getIncomingRequest(SnmpPduFactory p0);
    
    public abstract SnmpIncomingResponse getIncomingResponse(SnmpPduFactory p0);
    
    public abstract SnmpPdu getRequestPdu(SnmpParams p0, int p1) throws SnmpStatusException;
    
    public abstract int encode(int p0, int p1, int p2, byte p3, int p4, SnmpSecurityParameters p5, byte[] p6, byte[] p7, byte[] p8, int p9, byte[] p10) throws SnmpTooBigException;
    
    public abstract int encodePriv(int p0, int p1, int p2, byte p3, int p4, SnmpSecurityParameters p5, byte[] p6, byte[] p7) throws SnmpTooBigException;
    
    public abstract SnmpDecryptedPdu decode(byte[] p0) throws SnmpStatusException;
    
    public abstract int encode(SnmpDecryptedPdu p0, byte[] p1) throws SnmpTooBigException;
    
    public abstract void setMsgTranslator(SnmpMsgTranslator p0);
    
    public abstract SnmpMsgTranslator getMsgTranslator();
}
